#[doc = "Reader of register EWCTRL"]
pub type R = crate::R<u8, super::EWCTRL>;
#[doc = "Writer for register EWCTRL"]
pub type W = crate::W<u8, super::EWCTRL>;
#[doc = "Register EWCTRL `reset()`'s with value 0x0b"]
impl crate::ResetValue for super::EWCTRL {
    type Type = u8;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x0b
    }
}
#[doc = "Early Warning Interrupt Time Offset\n\nValue on reset: 11"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum EWOFFSET_A {
    #[doc = "0: 8 clock cycles"]
    _8,
    #[doc = "1: 16 clock cycles"]
    _16,
    #[doc = "2: 32 clock cycles"]
    _32,
    #[doc = "3: 64 clock cycles"]
    _64,
    #[doc = "4: 128 clock cycles"]
    _128,
    #[doc = "5: 256 clock cycles"]
    _256,
    #[doc = "6: 512 clock cycles"]
    _512,
    #[doc = "7: 1024 clock cycles"]
    _1K,
    #[doc = "8: 2048 clock cycles"]
    _2K,
    #[doc = "9: 4096 clock cycles"]
    _4K,
    #[doc = "10: 8192 clock cycles"]
    _8K,
    #[doc = "11: 16384 clock cycles"]
    _16K,
}
impl From<EWOFFSET_A> for u8 {
    #[inline(always)]
    fn from(variant: EWOFFSET_A) -> Self {
        match variant {
            EWOFFSET_A::_8 => 0,
            EWOFFSET_A::_16 => 1,
            EWOFFSET_A::_32 => 2,
            EWOFFSET_A::_64 => 3,
            EWOFFSET_A::_128 => 4,
            EWOFFSET_A::_256 => 5,
            EWOFFSET_A::_512 => 6,
            EWOFFSET_A::_1K => 7,
            EWOFFSET_A::_2K => 8,
            EWOFFSET_A::_4K => 9,
            EWOFFSET_A::_8K => 10,
            EWOFFSET_A::_16K => 11,
        }
    }
}
#[doc = "Reader of field `EWOFFSET`"]
pub type EWOFFSET_R = crate::R<u8, EWOFFSET_A>;
impl EWOFFSET_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, EWOFFSET_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(EWOFFSET_A::_8),
            1 => Val(EWOFFSET_A::_16),
            2 => Val(EWOFFSET_A::_32),
            3 => Val(EWOFFSET_A::_64),
            4 => Val(EWOFFSET_A::_128),
            5 => Val(EWOFFSET_A::_256),
            6 => Val(EWOFFSET_A::_512),
            7 => Val(EWOFFSET_A::_1K),
            8 => Val(EWOFFSET_A::_2K),
            9 => Val(EWOFFSET_A::_4K),
            10 => Val(EWOFFSET_A::_8K),
            11 => Val(EWOFFSET_A::_16K),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `_8`"]
    #[inline(always)]
    pub fn is_8(&self) -> bool {
        *self == EWOFFSET_A::_8
    }
    #[doc = "Checks if the value of the field is `_16`"]
    #[inline(always)]
    pub fn is_16(&self) -> bool {
        *self == EWOFFSET_A::_16
    }
    #[doc = "Checks if the value of the field is `_32`"]
    #[inline(always)]
    pub fn is_32(&self) -> bool {
        *self == EWOFFSET_A::_32
    }
    #[doc = "Checks if the value of the field is `_64`"]
    #[inline(always)]
    pub fn is_64(&self) -> bool {
        *self == EWOFFSET_A::_64
    }
    #[doc = "Checks if the value of the field is `_128`"]
    #[inline(always)]
    pub fn is_128(&self) -> bool {
        *self == EWOFFSET_A::_128
    }
    #[doc = "Checks if the value of the field is `_256`"]
    #[inline(always)]
    pub fn is_256(&self) -> bool {
        *self == EWOFFSET_A::_256
    }
    #[doc = "Checks if the value of the field is `_512`"]
    #[inline(always)]
    pub fn is_512(&self) -> bool {
        *self == EWOFFSET_A::_512
    }
    #[doc = "Checks if the value of the field is `_1K`"]
    #[inline(always)]
    pub fn is_1k(&self) -> bool {
        *self == EWOFFSET_A::_1K
    }
    #[doc = "Checks if the value of the field is `_2K`"]
    #[inline(always)]
    pub fn is_2k(&self) -> bool {
        *self == EWOFFSET_A::_2K
    }
    #[doc = "Checks if the value of the field is `_4K`"]
    #[inline(always)]
    pub fn is_4k(&self) -> bool {
        *self == EWOFFSET_A::_4K
    }
    #[doc = "Checks if the value of the field is `_8K`"]
    #[inline(always)]
    pub fn is_8k(&self) -> bool {
        *self == EWOFFSET_A::_8K
    }
    #[doc = "Checks if the value of the field is `_16K`"]
    #[inline(always)]
    pub fn is_16k(&self) -> bool {
        *self == EWOFFSET_A::_16K
    }
}
#[doc = "Write proxy for field `EWOFFSET`"]
pub struct EWOFFSET_W<'a> {
    w: &'a mut W,
}
impl<'a> EWOFFSET_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: EWOFFSET_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "8 clock cycles"]
    #[inline(always)]
    pub fn _8(self) -> &'a mut W {
        self.variant(EWOFFSET_A::_8)
    }
    #[doc = "16 clock cycles"]
    #[inline(always)]
    pub fn _16(self) -> &'a mut W {
        self.variant(EWOFFSET_A::_16)
    }
    #[doc = "32 clock cycles"]
    #[inline(always)]
    pub fn _32(self) -> &'a mut W {
        self.variant(EWOFFSET_A::_32)
    }
    #[doc = "64 clock cycles"]
    #[inline(always)]
    pub fn _64(self) -> &'a mut W {
        self.variant(EWOFFSET_A::_64)
    }
    #[doc = "128 clock cycles"]
    #[inline(always)]
    pub fn _128(self) -> &'a mut W {
        self.variant(EWOFFSET_A::_128)
    }
    #[doc = "256 clock cycles"]
    #[inline(always)]
    pub fn _256(self) -> &'a mut W {
        self.variant(EWOFFSET_A::_256)
    }
    #[doc = "512 clock cycles"]
    #[inline(always)]
    pub fn _512(self) -> &'a mut W {
        self.variant(EWOFFSET_A::_512)
    }
    #[doc = "1024 clock cycles"]
    #[inline(always)]
    pub fn _1k(self) -> &'a mut W {
        self.variant(EWOFFSET_A::_1K)
    }
    #[doc = "2048 clock cycles"]
    #[inline(always)]
    pub fn _2k(self) -> &'a mut W {
        self.variant(EWOFFSET_A::_2K)
    }
    #[doc = "4096 clock cycles"]
    #[inline(always)]
    pub fn _4k(self) -> &'a mut W {
        self.variant(EWOFFSET_A::_4K)
    }
    #[doc = "8192 clock cycles"]
    #[inline(always)]
    pub fn _8k(self) -> &'a mut W {
        self.variant(EWOFFSET_A::_8K)
    }
    #[doc = "16384 clock cycles"]
    #[inline(always)]
    pub fn _16k(self) -> &'a mut W {
        self.variant(EWOFFSET_A::_16K)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x0f) | ((value as u8) & 0x0f);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:3 - Early Warning Interrupt Time Offset"]
    #[inline(always)]
    pub fn ewoffset(&self) -> EWOFFSET_R {
        EWOFFSET_R::new((self.bits & 0x0f) as u8)
    }
}
impl W {
    #[doc = "Bits 0:3 - Early Warning Interrupt Time Offset"]
    #[inline(always)]
    pub fn ewoffset(&mut self) -> EWOFFSET_W {
        EWOFFSET_W { w: self }
    }
}
